<template>
    <app-layout>
        <div class="row justify-content-center">
            <div class="col-lg-6">
                <h1 class="h2 mb-3">{{ map.name }}</h1>
                
                <form @submit.prevent="submit(route('server.maps.update', map))">
                    <form-field text="Custom Name" id="inputCustomName" :errors="form.errors.custom_name" v-slot="slotProps">
                        <form-input v-model="form.custom_name" v-bind="slotProps" />
                    </form-field>
                    
                    <form-field text="Mission Type" :description="missionTypeDescription" id="inputMissionType" :errors="form.errors['settings.mission_type']" v-slot="slotProps">
                        <form-text>multiplayer_</form-text>
                        <form-input v-model="form.settings.mission_type" v-bind="slotProps" placeholder="sg" />
                    </form-field>
                    
                    <form-field text="Round Time Limit" id="inputRoundTimeLimit" :errors="form.errors['settings.set_round_max_seconds']" v-slot="slotProps">
                        <form-input v-model="form.settings.set_round_max_seconds" v-bind="slotProps" placeholder="&lt;default&gt;" />
                        <form-text>seconds</form-text>
                    </form-field>
                    
                    <form-field text="Player Count Lmits" id="inputPlayerLimitMin" :errors="[form.errors.min_players, form.errors.max_players]" v-slot="slotProps">
                        <form-input v-model="form.min_players" v-bind="slotProps" :error="slotProps.error[0]" placeholder="0" />
                        <form-text>-</form-text>
                        <form-input v-model="form.max_players" :error="slotProps.error[1]" id="inputPlayerLimitMax" placeholder="∞" />
                    </form-field>
                    
                    <form-field text="Build Points" id="inputBuildPointsTeam1" :errors="[form.errors['settings.set_map_defender_bp'], form.errors['settings.set_map_attacker_bp']]" v-slot="slotProps">
                        <form-text>Defender</form-text>
                        <form-input v-model="form.settings.set_map_defender_bp" v-bind="slotProps" :error="slotProps.error[0]" placeholder="&lt;default&gt;" />
                        <form-text>Attacker</form-text>
                        <form-input v-model="form.settings.set_map_attacker_bp" :error="slotProps.error[1]" id="inputBuildPointsTeam2" placeholder="&lt;default&gt;" />
                    </form-field>
                    
                    <form-field text="Respawn Period" id="inputRespawnPeriod" :errors="form.errors['settings.set_respawn_period']" v-slot="slotProps">
                        <form-input v-model="form.settings.set_respawn_period" v-bind="slotProps" placeholder="&lt;default&gt;" />
                        <form-text>seconds</form-text>
                    </form-field>
                    
                    <form-field text="Team Point Limit" id="inputTeamPointLimit" :errors="form.errors['settings.set_team_point_limit']" v-slot="slotProps">
                        <form-input v-model="form.settings.set_team_point_limit" v-bind="slotProps" placeholder="&lt;default&gt;" />
                    </form-field>
                    
                    <form-field text="Team Points Gained For Flags" id="inputTeamPointsFlag" :errors="form.errors['settings.set_team_points_gained_for_flags']" v-slot="slotProps">
                        <form-input v-model="form.settings.set_team_points_gained_for_flags" v-bind="slotProps" placeholder="&lt;default&gt;" />
                    </form-field>
                    
                    <form-checkbox-field text="Votable By">
                        <form-checkbox id="inputVotableAdmin" v-model="form.admin_votable">Admins</form-checkbox>
                        <form-checkbox id="inputVotablePlayer" v-model="form.player_votable">All Players <span class="form-text">(Including Admins)</span></form-checkbox>
                    </form-checkbox-field>
                    
                    <form-field text="Upload Image" id="inputUploadImage" :errors="form.errors.uploaded_image" v-slot="slotProps">
                        <form-input v-bind="slotProps" type="file" accept="image/*" @input="form.uploaded_image = $event.target.files[0]" /> 
                    </form-field>
                    
                    <div v-if="map.image" class="mb-3">
                        <a :href="route('imagecache', ['original', map.image])" target="_blank">
                            <img :src="route('imagecache', ['large', map.image])" class="img-fluid" />
                        </a>
                    </div>
                    
                    <form-button :disabled="form.processing">Save Changes</form-button>
                </form>
            </div>
        </div>
    </app-layout>
</template>

<script>
    import { useForm } from '@inertiajs/inertia-vue3'
    import AppLayout from '@/Layouts/AppLayout'
    import FormInput from '@/Components/Form/FormInput'
    import FormField from '@/Components/Form/FormField'
    import FormText from '@/Components/Form/FormText'
    import FormButton from '@/Components/Form/FormButton'
    import FormCheckboxField from '@/Components/Form/FormCheckboxField'
    import FormCheckbox from '@/Components/Form/FormCheckbox'
    import FormTextarea from '@/Components/Form/FormTextarea'
    
    export default {
        props: {
            'map': Object,
            'mission_types': Array,
        },
        
        components: {
            AppLayout,
            FormInput,
            FormField,
            FormText,
            FormButton,
            FormCheckboxField,
            FormCheckbox,
            FormTextarea,
        },
        
        data() {
            return {
                missionTypeDescription: null,
            }
        },
        
        mounted() {
            this.missionTypeDescription = 'Possible values: ' + this.mission_types.join(', ')
            
            this.form.custom_name = this.map.custom_name;
            this.form.min_players = this.map.min_players;
            this.form.max_players = this.map.max_players;
            this.form.admin_votable = this.map.admin_votable;
            this.form.player_votable = this.map.player_votable;
            
            this.form.settings = Object.assign(this.form.settings, this.map.settings);
        },
        
        setup () {
            const form = useForm({
                _method: 'patch',
                
                custom_name: null,
                min_players: null,
                max_players: null,
                admin_votable: false,
                player_votable: false,
                settings: {
                    mission_type: null,
                    set_round_max_seconds: null,
                    set_map_defender_bp: null,
                    set_map_attacker_bp: null,
                    set_respawn_period: null,
                    set_team_point_limit: null,
                    set_team_points_gained_for_flags: null,
                },
                uploaded_image: null,
            })
            
            function submit(path) {
                form.post(path, {
                    // fixes error on image upload
                    preserveState: (page) => Object.keys(page.props.errors).length,
                })
            }

            return { form, submit }
        },
    }
</script>